<template>
  <q-page padding>
    <div class="text-h5 q-mb-md">Gestion de experiencias</div>

    <q-card class="q-mt-sm">
      <q-list bordered>
        <q-expansion-item icon="filter_alt" label="Filtros Avanzados">
          <template v-slot:header>
            <q-item-section> Filtros Avanzados </q-item-section>
            <q-item-section side v-if="ExperienciasListadoStore.filtroActivado">
              <q-badge color="blue"> Existe un filtro aplicado </q-badge>
            </q-item-section>
          </template>
          <q-card>
            <q-card-section>
              <div class="q-col-gutter-md row">
                <q-input
                  class="col col-sm-4 col-xs-12"
                  v-model="ExperienciasListadoStore.filtros.query"
                  label="Buscar"
                  stack-label
                  dense
                />

                <q-select
                  class="col col-sm-2 col-xs-12"
                  v-model="ExperienciasListadoStore.filtros.tipo"
                  :options="experienciaListadoSelect.tipo"
                  label="Tipo"
                  dense
                  emit-value
                  stack-label
                  map-options
                />

                <q-select
                  class="col col-sm-2 col-xs-12"
                  v-model="ExperienciasListadoStore.filtros.estado"
                  :options="experienciaListadoSelect.estado"
                  label="Estado"
                  dense
                  emit-value
                  stack-label
                  map-options
                />
              </div>
            </q-card-section>
            <q-card-actions align="right">
              <q-btn flat color="primary" @click="onFiltrar">Filtrar</q-btn>
              <q-btn flat color="red" @click="onResetFiltros">
                Borrar Filtro
              </q-btn>
            </q-card-actions>
          </q-card>
        </q-expansion-item>
      </q-list>
    </q-card>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="ExperienciasListadoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:body-cell-experiencia="props">
          <q-td :props="props">
            <q-item>
              <q-item-section>
                <q-item-label> {{ props.row.nombre }}</q-item-label>
                <q-item-label caption lines="2">
                  <span>Organismo :</span>
                  {{ props.row.organismo.full }}
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-td>
        </template>

        <template v-slot:body-cell-datos="props">
          <q-td :props="props">
            <q-item>
              <q-item-section>
                <q-item-label>
                  <span>Responsable :</span> {{ props.row.responsable }}
                </q-item-label>

                <q-item-label caption lines="3">
                  <span>Fecha. :</span> {{ $filters.Date(props.row.fecha) }}
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-td>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <div class="q-gutter-xs">
              <q-btn
                color="green"
                size="sm"
                :to="'/formacion/experiencias/detalle/' + props.row.uuid"
              >
                Cursada
              </q-btn>
              <q-btn
                color="blue"
                size="sm"
                :to="'/eventos/administracion/detalle/' + props.row.evento_uuid"
              >
                Evento
              </q-btn>
            </div>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, reactive } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import {
  useExperienciasStore,
  experienciaListadoSelect,
} from 'src/stores/formacion/experienciasStore';
import Loading from 'src/components/Loading.vue';

//Nombre	Fecha	Responsable	Opciones
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  {
    name: 'experiencia',
    label: 'Experiencia',
    field: 'experiencia',
    align: 'left',
  },
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },

  { name: 'opciones', label: 'opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: { Loading },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const ExperienciasListadoStore = useExperienciasStore();

    const filtros = reactive({
      tipo: 'miseventos',
      area: null,
      estado: 'activos',
    });

    onMounted(() => {
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      ExperienciasListadoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      ExperienciasListadoStore.filtroActivado = true;
      ExperienciasListadoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/formacion/cursos', {
          params: ExperienciasListadoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          ExperienciasListadoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      ExperienciasListadoStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      columnas,
      dataSet,
      ExperienciasListadoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      experienciaListadoSelect,
      filtros,
      loading,
    };
  },
});
</script>
